'''Game main module.

Contains the entry point used by the run_game.py script.

Feel free to put all your game code here, or in other modules in this "lib"
directory.
'''
import logging.config
import engine, constants
import sys

def main():
    log = init_logging()
    
    log.debug("Starting strlen")
    disable_sounds = 'nosound' in sys.argv
    game_engine = engine.Engine(disable_sounds = disable_sounds)
    game_engine.init_world()

def init_logging():
    logging.config.fileConfig(constants.LOG_CONFIG_FILE)  
    return logging.getLogger(constants.LOGGER_NAME)

