from World import character, projectile, world
import constants

class TestCollisions(object):
    def setup_method(self, method):
        self.world = world.World()

    def test_character_and_projectile_collide_when_at_same_location(self):
        hero = character.Character(10, 10)
        rock = projectile.Projectile(10, 10)
        
        self.world.add_object(hero)
        self.world.add_object(rock)

        assert rock.overlaps(hero)
        assert hero.overlaps(rock)


    def test_character_and_projectile_do_not_collide_when_at_different_location(self):
        hero = character.Character(100, 100)
        rock = projectile.Projectile(10, 10)
        
        self.world.add_object(hero)
        self.world.add_object(rock)

        assert not rock.overlaps(hero)
        assert not hero.overlaps(rock)

    def test_character_loses_one_life_point_when_it_collides_with_a_projectile(self):
        hero = character.Character(10, 10)
        rock = projectile.Projectile(100, 100)
        
        assert hero.life().remaining() == constants.FULL_LIFE
        rock.collide(hero)
        assert hero.life().remaining() == constants.FULL_LIFE - 1
