from World import projectile
import math

THRESHOLD = 0.01

class TestProjectile(object):

    # rapha: I think this test should be on world_object, rather than on projectile
    def test_projectile_should_move_in_a_straight_line(self):
        ball = projectile.Projectile(x = 0, y = 0, angle = 0, speed = 1)
        self.assert_next_position(ball, 1, 0)

        ball = projectile.Projectile(x = 0, y = 0, angle = 90, speed = 1)
        self.assert_next_position(ball, 0, -1)

        ball = projectile.Projectile(x = 0, y = 0, angle = 45, speed = math.sqrt(2))
        self.assert_next_position(ball, 1, -1)

        ball = projectile.Projectile(x = 1, y = -1, angle = 225, speed = math.sqrt(2))
        self.assert_next_position(ball, 0, 0)


    def test_projectile_hits_objects_it_collides_with(self):
        class hittableObject(object):
            def __init__(self):
                self.has_been_hit = False
            def hit(self):
                self.has_been_hit = True
            
        hero = hittableObject()
        rock = projectile.Projectile(0, 0, 0, 0)
    
        rock.collide(hero)

        assert hero.has_been_hit
                

    def assert_next_position(self, ball, x, y):
        ball_x, ball_y = ball.next_position()
        assert abs(ball_x - x) < THRESHOLD
        assert abs(ball_y - y) < THRESHOLD
    
