from World import string
import constants

class TestString(object):
    def test_string_length_should_decrease_when_burnt(self):
        piece_of_string = string.String(0,0, 5)
        piece_of_string.burn()
        assert piece_of_string.length() < 5
        
    def test_string_length_should_decrease_by_amount_burnt(self):
        piece_of_string = string.String(0,0, 5)
        piece_of_string.burn(3)
        assert piece_of_string.length() == 2
        
    def test_cannot_burn_more_than_length_of_string(self):
        piece_of_string = string.String(0, 0, 5)
        piece_of_string.burn(10)
        assert piece_of_string.length() == 0

    def test_string_should_die_after_burning(self):
        piece_of_string = string.String(0, 0, 1)
        for i in range(1 / constants.STRING_BURN_SPEED):
            piece_of_string.burn()
        piece_of_string.burn()
        assert piece_of_string.length() == 0
        assert piece_of_string.is_dead()
   
    def test_string_cannot_burn_by_negative_amount(self):
        piece_of_string = string.String(0, 0, 3)
        piece_of_string.burn(-5)
        assert piece_of_string.length() == 3
